stages:
- build
- publish
- can-i-deploy
- tag
- deploy

maven-build:
  image: maven:3-jdk-11
  stage: .pre
  script:
    - mvn clean install package
    - mv ./target/apiconsumer-0.0.122-SNAPSHOT.jar ./target/consumerbuild
  artifacts:
    paths:
      - ./target/




pact-publish:
  stage: publish
  image:
    name: pactfoundation/pact-cli:latest
    entrypoint: [""]
  script:
    - "pact publish ./target/pacts
        --consumer-app-version 177
        --tag main 
        --broker-base-url=https://ishcode.pactflow.io
        --broker-token=CDM1ulK4zsh5DI3uJ_0vGQ" 
  except: 
    - triggers          

pact-tag:
  image: pactfoundation/pact-cli:latest
  stage: tag
  script:
    - "pact-broker create-version-tag 
        --pacticipant=apiconsumer-0.0.122
        --version=177
        --tag=main
        --broker-base-url=https://ishcode.pactflow.io
        --broker-token=CDM1ulK4zsh5DI3uJ_0vGQ"  
  only:
    refs:
      - main      

.pact-can-i-deploy:
  image: 
    name: pactfoundation/pact-cli:latest
    entrypoint: [""]
  stage: can-i-deploy
  
  script:
    - "pact-broker can-i-deploy
         --pacticipant APIConsumerCatalogue
         --version 177
         --to production
         --broker-base-url https://ishcode.pactflow.io
         --broker-token CDM1ulK4zsh5DI3uJ_0vGQ"
         
   


     
deploy-job:
  stage: deploy
  script:
      - echo starting deployment
  when: manual
         

